#include "copyright.h"

/*=================================================================*
 * bmp.c - bmp rutines
 *
 * Description:
 *   Creat, Free, Read, Write BMP file format.
 *
 * RCS information:
 * ----------------
 * $RCSfile: bmp.h,v $
 * $Revision: 1.2 $
 * $Date: 1997/04/14 10:38:48 $
 *
 * Author: Ziv Yaniv email: zivy@cs.huji.ac.il
 *
 *=================================================================*/

#ifndef _BMP_FILE_H_
#define _BMP_FILE_H_

#include <stdio.h>

#ifndef BI_RGB 
#  define BI_RGB 0
#  define BI_RLE8 1
#  define BI_RLE4 2
#endif

typedef struct Rgb {
  unsigned char r;
  unsigned char g;
  unsigned char b;
}RgbRec,*RgbPtr;

typedef struct FileHeader {
  unsigned short bftype;
  unsigned short bfreserved1;
  unsigned short bfreserved2;
  unsigned long bfsize;
  unsigned long bfoffbits;
}BmpFileHeader,*BmpFileHeaderPtr;

typedef struct InfoHeader {
  unsigned long bisize;
  long biwidth;
  long biheight;
  unsigned short biplanes;
  unsigned short bibitcount;
  unsigned long bicompression;
  unsigned long bisizeimage;
  long bixpelspermeter;
  long biypelspermeter;
  unsigned long biclrused;
  unsigned long biclrimportant;
}BmpInfoHeader,*BmpInfoHeaderPtr;

typedef struct Quad {
  unsigned char blue;
  unsigned char green;
  unsigned char red;
  unsigned char reserved;
}RgbQuad,*RgbQuadPtr;

typedef struct Cmap {
  int size;
  RgbQuadPtr table;
}ColorMap,*ColorMapPtr;


typedef struct BFile {
  BmpFileHeader bfh;
  BmpInfoHeader bfih;
  ColorMapPtr cmap;
  RgbPtr *image;
}BmpFile,*BmpFilePtr;

short load_bmp_file(char *fname,BmpFilePtr bfptr);
short load_bmp_file_stream(FILE *input,BmpFilePtr bfptr);
short write_bmp24(char *fname,long width,long height,unsigned char *img);
short write_bmp24_stream(FILE *output,long width,long height,
			 unsigned char *img);
RgbPtr bmp_entry(BmpFilePtr bfptr,int i,int j);
void release_bmp_file(BmpFilePtr bfptr);
long bmp_width(BmpFilePtr bfptr);
long bmp_height(BmpFilePtr bfptr);

#endif /*_BMP_FILE_H_*/






