#include "copyright.h"
#include "error_msg.h"

//=================================================================
// bmp_env.cxx - C++ envelope portable 'any' file format.
//
// Description:
//	This file encapsulate the bmp C code. This method is 
//      applicable for existing C code for other formats as well.
//
//
// RCS information:
// ----------------
// $RCSfile: bmp_env.cpp,v $
// $Revision: 1.1 $
// $Date: 2002/01/29 20:20:22 $
//
//=================================================================

#include <stdio.h>
//#include <malloc.h>
#include <stdlib.h>

#include "bmp_env.h"


//===============================
// Read - read Bmp format files
//================================

bmp &bmp::Read(FILE *fp)
{
  BmpFile tmp_bmp;

  if ((load_bmp_file_stream(fp, &tmp_bmp)) == -1){
    error_msg("bmp::Read - load_bmp_file_stream failed",0);
    clip_exception(READ);
  }
  width = bmp_width(&tmp_bmp);
  height = bmp_height(&tmp_bmp);
  if ((data = (unsigned char *) malloc(width * height * sizeof(RgbRec))) == NULL){
	error_msg("bmp::Read - malloc failed",0);
    clip_exception(READ);
  }
  
  RgbPtr ent;
  unsigned char *p = data;
  for(register unsigned i=0; i< height; i++){
    for (register unsigned j=0; j<width; j++){
      ent  =  bmp_entry(&tmp_bmp,i,j);
      *p++ =  ent->r ;
      *p++ =  ent->g ;
      *p++ =  ent->b ;
    }
  } 
  release_bmp_file(&tmp_bmp);
  return *this;
}


bmp &bmp::Read(char *fname)
{
  BmpFile tmp_bmp;

  if ((load_bmp_file(fname, &tmp_bmp)) == -1){
    error_msg("bmp::Load_file(%s) failed", (int) fname);
    clip_exception(READ);
  }
  width = bmp_width(&tmp_bmp);
  height = bmp_height(&tmp_bmp);
  if ((data = 
       (unsigned char *) malloc(width * height * sizeof(RgbRec))) == NULL){
	error_msg("bmp::Read - malloc failed",0);
	clip_exception(MALLOC);
  }
  
  RgbPtr ent;
  unsigned char *p = data;
  for(register unsigned i=0; i< height; i++){
    for (register unsigned j=0; j<width; j++){
      ent  =  bmp_entry(&tmp_bmp,i,j);
      if(ent==NULL)
	printf("entry %d %d \n",i,j);
      *p++ =  ent->r ;
      *p++ =  ent->g ;
      *p++ =  ent->b ;
    }
  } 
  release_bmp_file(&tmp_bmp);
  return *this;
}


//================================
// Write - write bmp format image
//================================

void bmp::Write(FILE *fp)
{
  write_bmp24_stream(fp,width,height,data);
}

void bmp::Write(char *fname)
{
  write_bmp24(fname,width,height,data);
}



