#include "copyright.h"

//=================================================================
// color.cpp - color utilities
//
// Description:
//
// RCS information:
// ----------------
// $RCSfile: color.cpp,v $
// $Revision: 1.1 $
// $Date: 2002/01/29 20:20:22 $
//
//=================================================================

#include "rgb.h"
#include "cie.h"


//======= fCiePix =========


fCiePix &fCiePix::operator=(const fRgbPix &pix){	
    CieX() = pix.GetCieX();
    CieY() = pix.GetCieY();
    CieZ() = pix.GetCieZ();
    return *this;
}

fCiePix &fCiePix::operator=(const bRgbPix &pix){	
    CieX() = pix.GetCieX();
    CieY() = pix.GetCieY();
    CieZ() = pix.GetCieZ();
    return *this;
}
  
// casting operators
  
fCiePix::operator fRgbPix() {
    fRgbPix tmp;
    tmp = *this;
    return tmp;
}

fCiePix::operator bRgbPix() {
    bRgbPix tmp;
    tmp = *this;
    return tmp;
}


//======= fRgbPix =========

fRgbPix &fRgbPix::operator=(const fCiePix &pix){	
    Red()   = pix.GetRed();
    Green() = pix.GetGreen();
    Blue()  = pix.GetBlue();
    return *this;
}

fRgbPix &fRgbPix::operator=(const bRgbPix &pix){	
    Red()   = pix.Red();
    Green() = pix.Green();
    Blue()  = pix.Blue();
    return *this;
}

// casting operators

fRgbPix::operator fCiePix() {
    fCiePix tmp;
    tmp = *this;
    return tmp;
}

fRgbPix::operator bRgbPix() {
    bRgbPix tmp;
    tmp = *this;
    return tmp;
}
  
//======= bRgbPix =========

bRgbPix &bRgbPix::operator=(const fCiePix &pix){	
    Red()   = (unsigned char) (pix.GetRed() + 0.5);
    Green() = (unsigned char) (pix.GetRed() + 0.5);
    Blue()  = (unsigned char) (pix.GetRed() + 0.5);
    return *this;
}

bRgbPix &bRgbPix::operator=(const fRgbPix &pix){	
    Red()   = (unsigned char) (pix.Red()   + 0.5);
    Green() = (unsigned char) (pix.Green() + 0.5);
    Blue()  = (unsigned char) (pix.Blue()  + 0.5);
    return *this;
}

// casting operators

bRgbPix::operator fCiePix() {
    fCiePix tmp;
    tmp = *this;
    return tmp;
}

bRgbPix::operator fRgbPix() {
    bRgbPix tmp;
    tmp = *this;
    return tmp;
}
  
