
// Color compressed movie class

#ifndef MOVIE_H
#define MOVIE_H


#include "zlib.h"
#include "error_msg.h"

// directory is not compressed

#ifndef MAX_FRAMES
#	define INITIAL_FRAME_NO	  30*60		    // 1 minutes
#	define MAX_FRAME_SIZE    1024*768*3		// 1024x768 color
#endif

typedef struct {
	char		magic[16];
	unsigned short	width;
	unsigned short	height;
	unsigned long	dir_offset;
	unsigned long	frame_count;
	unsigned char	reserved[1024];
} header_t;

class Movie {

	//---------------------
	// Data Items
	//---------------------
	header_t header;
	unsigned long	cur_frame;
	unsigned long	dir_size;
	unsigned long	*dir;
	unsigned char   *buf;
	unsigned char   *chan;
	int fd;

	//----------------------
	// functions
	//----------------------
public:

	unsigned short GetWidth()  { return header.width; }
	unsigned short GetHeight() { return header.height; }
	unsigned long  GetCount() { return  header.frame_count; }

	void	Create(char *fname);
	float	Add_frame(bRgbImg &img);
	void	Open(char *fname);
	void	Get_frame(bRgbImg &img, long fno);

	Movie();
	~Movie();
};
	

#endif
