#include "copyright.h"
#include "error_msg.h"

//=================================================================
// pnm_env.cxx - C++ envelope portable 'any' file format.
//
// Description:
//	This file encapsulate the pnm C code. This method is 
//      applicable for existing C code for other formats as well.
//
//
// RCS information:
// ----------------
// $RCSfile: pnm_env.cpp,v $
// $Revision: 1.1 $
// $Date: 2002/01/29 20:20:22 $
//
//=================================================================

#include <stdio.h>
//#include <malloc.h>
#include <stdlib.h>

#include "pnm_env.h"


//===============================
// Read - read Pnm format files
//================================

pnm &pnm::Read(FILE *fp)
{
  if ((pnm_img = read_image(fp)) == NULL) {
	error_msg("pnm::Read(FILE *) - failed",0);
	clip_exception(READ);
  }
  return *this;
}


pnm &pnm::Read(char *fname)
{
  FILE *fp;
  
  if ((fp = fopen(fname,"rb")) == NULL){
	error_msg("pnm::Read - open(%s) failed", (int) fname);
	clip_exception(OPEN);
  }

  pnm &retval = Read(fp);
  fclose(fp);

  return retval;
}


//================================
// Write - write pnm format image
//================================

void pnm::Write(FILE *fp)
{
  write_image(fp,pnm_img);
}

void pnm::Write(char *fname)
{
  FILE *fp;
  
  if ((fp = fopen(fname,"wb")) == NULL){
	error_msg("pnm::Write - open(%s) failed", (int) fname);
	clip_exception(OPEN);
  }
  Write(fp);
  fclose(fp);
}



